:::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::
::					  MADE   BY					 	 ::
::					  ENDURANCE						 ::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::
::					 CONTACT  ME 					 ::
::					 ON  DISCORD					 ::
::													 ::
::													 ::
::				   Endurance #1694					 ::
::													 ::
::      if YOU HAVE ANY QUESTIONS OR PROBLEMS.	     ::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::

@echo off
setlocal enabledelayedexpansion

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:setConstants
set "THIS_VERSION=1.02"
title Rename Savegames v%THIS_VERSION%

set "THIS_DIRECTORY=%~dp0"
set "THIS_DIRECTORY=%THIS_DIRECTORY:~0,-1%"

set "FALSE=0"
set "TRUE=1"

set "MP1_NAME=Max Payne 1"
set "MP2_NAME=Max Payne 2"
set "MP1_EXTENSION=mps"
set "MP2_EXTENSION=mp2s"

set "AUTOSAVE_SLOT_YES_TEXT=Yes  "
set "AUTOSAVE_SLOT_NO_TEXT=No   "
set "QUICKSAVE_SLOT_YES_TEXT=Yes"
set "QUICKSAVE_SLOT_NO_TEXT=No "

for /F %%a in ('echo prompt $E^| cmd') do set "ESC=%%a"
set "CSI=%ESC%["

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:setupForMenu
set /a "menuMainLine=1"
call :loadSettings

if %saveNeeded%==%FALSE% (
	set "savegameFolderSaved=%TRUE%"
	
	goto menuMain
) else (
	set "savegameFolderSaved=%FALSE%"
	
	goto menuMainNoSave
)

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:menuMainNoSave
echo %CSI%%colorBKG%%colorTXT%
cls

echo Press %keyUp% (up) and %keyDown% (down) to highlight an option, and press %keySelect% to select the highlighted option.
echo.

if %menuMainLine% EQU 1 (call :colorEcho "[X] Setup Program" colorBKG colorTXT colorHIL) else (echo [ ] Setup Program)
if %menuMainLine% EQU 2 (call :colorEcho "[X] Exit Program" colorBKG colorTXT colorHIL) else (echo [ ] Exit Program)

choice /c %keyUp%%keyDown%%keySelect% /n > nul

if %ERRORLEVEL% EQU 3 (
	if %menuMainLine% EQU 1 (goto configureSettings)
	if %menuMainLine% EQU 2 (
		if %savegameFolderSaved%==%FALSE% (
			del "%SETTINGS_FILE_PATH%" > nul 2>&1
		)
		
		exit
	)
)
if %ERRORLEVEL% EQU 2 (set /a menuMainLine+=1)
if %ERRORLEVEL% EQU 1 (set /a menuMainLine-=1)

if %menuMainLine% EQU 0 (set menuMainLine=2)
if %menuMainLine% EQU 3 (set menuMainLine=1)

goto menuMainNoSave

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:menuMain
echo %CSI%%colorBKG%%colorTXT%
cls

echo Press %keyUp% (up) and %keyDown% (down) to highlight an option, and press %keySelect% to select the highlighted option.
echo.

if %menuMainLine% EQU 1 (call :colorEcho "[X] Rename Savegames" colorBKG colorTXT colorHIL) else (echo [ ] Rename Savegames)
if %menuMainLine% EQU 2 (call :colorEcho "[X] Change Savegame Folder" colorBKG colorTXT colorHIL) else (echo [ ] Change Savegame Folder)
if %menuMainLine% EQU 3 (call :colorEcho "[X] Change Savegame Slot Preferences" colorBKG colorTXT colorHIL) else (echo [ ] Change Savegame Slot Preferences)
echo.
if %menuMainLine% EQU 4 (call :colorEcho "[X] Exit Program" colorBKG colorTXT colorHIL) else (echo [ ] Exit Program)

choice /c %keyUp%%keyDown%%keySelect% /n > nul

if %ERRORLEVEL% EQU 3 (
	if %menuMainLine% EQU 1 (call :renameSavegameMenu %FALSE%)
	if %menuMainLine% EQU 2 (call :changeSavegameFolder %FALSE%)
	if %menuMainLine% EQU 3 (call :changeSavegameSlotPreferences %FALSE%)
	if %menuMainLine% EQU 4 (exit)
)
if %ERRORLEVEL% EQU 2 (set /a menuMainLine+=1)
if %ERRORLEVEL% EQU 1 (set /a menuMainLine-=1)

if %menuMainLine% EQU 0 (set menuMainLine=4)
if %menuMainLine% EQU 5 (set menuMainLine=1)

goto menuMain

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:configureSettings
echo %CSI%%colorBKG%%colorTXT%
cls

if %savegameFolderSaved%==%TRUE% (
	call :changeSavegameSlotPreferences %FALSE%
) else (
	call :changeSavegameFolder %TRUE%
	set "savegameFolderSaved=%TRUE%"
	call :changeSavegameSlotPreferences %TRUE%
)

goto menuMain

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:changeSavegameFolder
set "savegameDirectoryOld=%savegameDirectory%"
set "gameNameOld=%gameName%"
set "savegameExtensionOld=%savegameExtension%"
set "saveNeededOld=%saveNeeded%"
set /a "menuMainLine=1"

echo %CSI%%colorBKG%%colorTXT%
cls

echo %savegameDirectory% is set as your %gameName% Savegames folder.
echo.

set /p savegameDirectory="Please enter the full path of the folder you want to assign as the savegames folder (press enter if the current folder is correct): "

if "!savegameDirectory:~-1!"=="\" (
	set savegameDirectory=!savegameDirectory:~0,-1!
)

cd "!savegameDirectory!" > nul 2>&1

if !ERRORLEVEL! EQU 1 (
	echo.
	echo The specified directory could not be found.
	echo Press ANY key to go back to the main menu...
	pause > nul 2>&1
	
	set "savegameDirectory=%savegameDirectoryOld%"
	
	if %saveNeeded%==%TRUE% (
		goto menuMainNoSave
	) else (
		goto menuMain
	)
)

echo.
choice /c:c12 /n /m "Does this folder contain Max Payne [1] savegames or Max Payne [2] savegames [1/2, or C to go back to the menu]? "

if !ERRORLEVEL! EQU 3 (
	set "gameName=%MP2_NAME%"
	set "savegameExtension=%MP2_EXTENSION%"
)
if !ERRORLEVEL! EQU 2 (
	set "gameName=%MP1_NAME%"
	set "savegameExtension=%MP1_EXTENSION%"
)
if !ERRORLEVEL! EQU 1 (
	set "savegameDirectory=%savegameDirectoryOld%"
	
	if %saveNeeded%==%TRUE% (
		goto menuMainNoSave
	) else (
		goto menuMain
	)
)

call :saveAllSettings
set "saveNeeded=%saveNeededOld%"
set "savegameFolderSaved=%TRUE%"

if "%~1"=="%FALSE%" (
	echo Press ANY key to go back to the main menu...
	pause > nul 2>&1
)

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:changeSavegameSlotPreferences
set "useAutosaveSlotOld=%useAutosaveSlot%"
set "autosaveSlotTextOld=%autosaveSlotText%"
set "saveNeededOld=%saveNeeded%"
set /a "menuMainLine=1"

echo %CSI%%colorBKG%%colorTXT%

if "%~1"=="%FALSE%" (
	cls
)

call :displaySettings
echo.

choice /c:cny /n /m "Should a savegame take up an empty autosave slot [Y/N, or C to cancel]? "

if %ERRORLEVEL% EQU 3 (
	set useAutosaveSlot=%TRUE%
	set "autosaveSlotText=%AUTOSAVE_SLOT_YES_TEXT%"
)
if %ERRORLEVEL% EQU 2 (
	set useAutosaveSlot=%FALSE%
	set "autosaveSlotText=%AUTOSAVE_SLOT_NO_TEXT%"
)
if %ERRORLEVEL% EQU 1 (
	if %saveNeeded%==%FALSE% (
		goto menuMain
	) else (
		set "savegameDirectory=%savegameDirectoryOld%"
		set "gameName=%gameNameOld%"
		set "savegameExtension=%savegameExtensionOld%"
		
		goto menuMainNoSave
	)
)

choice /c:cny /n /m "Should a savegame take up any empty quicksave slots [Y/N, or C to cancel]? "

if %ERRORLEVEL% EQU 3 (
	set useQuicksaveSlots=%TRUE%
	set "quicksaveSlotText=%QUICKSAVE_SLOT_YES_TEXT%"
)
if %ERRORLEVEL% EQU 2 (
	set useQuicksaveSlots=%FALSE%
	set "quicksaveSlotText=%QUICKSAVE_SLOT_NO_TEXT%"
)
if %ERRORLEVEL% EQU 1 (
	set "useAutosaveSlot=%useAutosaveSlotOld%"
	set "autosaveSlotText=%autosaveSlotTextOld%"
	
	if %saveNeeded%==%FALSE% (
		goto menuMain
	) else (
		set "savegameDirectory=%savegameDirectoryOld%"
		set "gameName=%gameNameOld%"
		set "savegameExtension=%savegameExtensionOld%"
		
		goto menuMainNoSave
	)
)

call :saveAllSettings
set "saveNeeded=%FALSE%"

echo Press ANY key to go back to the main menu...
pause > nul 2>&1

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:renameSavegameMenu
set /a "menuMainLine=1"
echo %CSI%%colorBKG%%colorTXT%

if "%~1"=="%FALSE%" (
	cls
)

call :displaySettings
echo.
echo %savegameDirectory% is set as your %gameName% Savegames folder.
choice /c:ny /n /m "Would you like to rename the savegames in this directory with the settings above [Y/N]? "

if %ERRORLEVEL% EQU 2 (
	call :renameSavegames
)
if %ERRORLEVEL% EQU 1 (
	goto menuMain
)

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:renameSavegames
cls

set /a "openSavegameSlotCount=0"
set /a "usedSavegameSlotCount=0"
set /a "savegameFileIndex=1"
set /a "currentFileIndex=1"
set /a "declinedSavegameSlots=0"
set /a "tempResult=0"

set "currentSaveSlot="
set "openSavegameSlots="
set "usedSavegameSlots="
set "saveSlotFilePath="
set "saveSlotFileName="
set "currentSavegameName="
set "tempFilePath="

if !useAutosaveSlot!==%TRUE% (
	set "currentSaveSlot=0"
) else if !useQuicksaveSlots!==%TRUE% (
	call :usedSavegameSlotsAdd 0
	set "currentSaveSlot=1"
	
	call :getSavegameSlotFilePath 0
	if not exist "!saveSlotFilePath!" (
		set /a "declinedSavegameSlots+=1"
	)
) else (
	call :usedSavegameSlotsAdd 0
	call :usedSavegameSlotsAdd 1
	call :usedSavegameSlotsAdd 2
	set "currentSaveSlot=3"
	
	call :getSavegameSlotFilePath 0
	if not exist "!saveSlotFilePath!" (
		set /a "declinedSavegameSlots+=1"
	)
	
	call :getSavegameSlotFilePath 1
	if not exist "!saveSlotFilePath!" (
		set /a "declinedSavegameSlots+=1"
	)
	
	call :getSavegameSlotFilePath 2
	if not exist "!saveSlotFilePath!" (
		set /a "declinedSavegameSlots+=1"
	)
)

:::Get status of each savegame slot
set "openSavegameSlots="
for /l %%b in (!currentSaveSlot!, 1, 12) do (

	if %%b EQU 1 (
		if !useQuicksaveSlots!==%FALSE% (
			call :usedSavegameSlotsAdd 1
			call :usedSavegameSlotsAdd 2
			set "currentSaveSlot=3"
			
			call :getSavegameSlotFilePath 1
			if not exist "!saveSlotFilePath!" (
				set /a "declinedSavegameSlots+=1"
			)
			
			call :getSavegameSlotFilePath 2
			if not exist "!saveSlotFilePath!" (
				set /a "declinedSavegameSlots+=1"
			)
		)
	)
	
	call :getSavegameSlotFilePath !currentSaveSlot!
	if !currentSaveSlot! LEQ 12 (
		if exist "!saveSlotFilePath!" (
			call :usedSavegameSlotsAdd !currentSaveSlot!
		) else (
			call :openSavegameSlotsAdd !currentSaveSlot!
		)
	)
	
	set /a "currentSaveSlot+=1"
)

if !openSavegameSlotCount! EQU 0 (
	echo There are no free savegame slots in !savegameDirectory!.
	call :renameSavegameMenu %TRUE%
)

for /f "delims=" %%a in ('dir /b /a-d "!savegameDirectory!\*.!savegameExtension!" ^| find /c /v ""') do (
	@call set /a totalSavegameFiles=%%a
)

if !totalSavegameFiles! EQU 0 (
	echo There are no savegame files in !savegameDirectory!.
	call :renameSavegameMenu %TRUE%
)

set /a "tempResult=!totalSavegameFiles! + !declinedSavegameSlots!"
if !tempResult! EQU !usedSavegameSlotCount! (
	echo All savegames in the savegame folder are properly named^^!
	call :renameSavegameMenu %TRUE%
)

call :getUniqueFile "%THIS_DIRECTORY%\files" ".txt" tempFilePath

for /f "tokens=* delims=" %%b in ('dir /a-d /b "!savegameDirectory!\*.!savegameExtension!"') do (
	echo !savegameDirectory!\%%b>>"!tempFilePath!"
)

for %%a in (!openSavegameSlots!) do (
	set "currentSaveSlot=%%a"
	call :getSavegameSlotFileName !currentSaveSlot!
	set "currentSavegameName=!saveSlotFileName!"
	
	set currentFileIndex=1
	for /f "usebackq tokens=*" %%b in ("!tempFilePath!") do (
		if !saveRenamed!==%FALSE% (
			if !currentFileIndex! GEQ !savegameFileIndex! (
				set "currentFilePath=%%b"
				
				if defined usedSavegameSlots (
					for %%c in (!usedSavegameSlots!) do (
						call :getSavegameSlotFilePath %%c
						if "!currentFilePath!"=="!saveSlotFilePath!" (
							set "savegameSlotUsed=%TRUE%"
						)
					)
				)
				
				if !savegameSlotUsed!==%FALSE% (
					ren "!currentFilePath!" "!currentSavegameName!"
					call :usedSavegameSlotsAdd !currentSaveSlot! > nul 2>&1
					set "saveRenamed=%TRUE%"
				)
				
				set "savegameSlotUsed=%FALSE%"
				set /a "savegameFileIndex+=1"
			)
		)
		
		set /a "currentFileIndex+=1"
	)
	
	set "saveRenamed=%FALSE%"
	if !savegameFileIndex! GEQ !totalSavegameFiles! (
		break
	)
)

echo Savegames successfully renamed^^!

del "!tempFilePath!" > nul 2>&1
call :renameSavegameMenu %TRUE%

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:openSavegameSlotsAdd 
set saveSlot=%1

if defined openSavegameSlots (
	set "openSavegameSlots=!openSavegameSlots! "
)

set "openSavegameSlots=!openSavegameSlots!!saveSlot!"
set /a "openSavegameSlotCount+=1"

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:usedSavegameSlotsAdd 
set saveSlot=%1

if defined usedSavegameSlots (
	set "usedSavegameSlots=!usedSavegameSlots! "
)

set "usedSavegameSlots=!usedSavegameSlots!!saveSlot!"
set /a "usedSavegameSlotCount+=1"

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:getSavegameSlotFilePath
set saveSlot=%1
set "saveSlotFilePath=%savegameDirectory%\savegame0"

if !saveSlot! LSS 10 (
	set "saveSlotFilePath=!saveSlotFilePath!0"
)

set "saveSlotFilePath=!saveSlotFilePath!!saveSlot!.!savegameExtension!"

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:getSavegameSlotFileName
set saveSlot=%1
set "saveSlotFileName=savegame0"

if !saveSlot! LSS 10 (
	set "saveSlotFileName=!saveSlotFileName!0"
)

set "saveSlotFileName=!saveSlotFileName!!saveSlot!.!savegameExtension!"

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:getUniqueFile
setlocal
:getUniqueFileLoop
for /f "skip=1" %%A in ('wmic os get localDateTime') do (
	for %%B in (%%A) do (
		set "rtn=%~1_%%B%~2"
	)
)

if exist "%rtn%" (
	goto :getUniqueFileLoop
) else (
	type nul > "%rtn%"
)
endlocal & set "%~3=%rtn%"

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:saveAllSettings
echo "savegameDirectory=%savegameDirectory%" > "!SETTINGS_FILE_PATH!"
echo "gameName=%gameName%" >> "!SETTINGS_FILE_PATH!"
echo "savegameExtension=%savegameExtension%" >> "!SETTINGS_FILE_PATH!"
echo "useAutosaveSlot=%useAutosaveSlot%" >> "!SETTINGS_FILE_PATH!"
echo "useQuicksaveSlots=%useQuicksaveSlots%" >> "!SETTINGS_FILE_PATH!"
REM echo "soundsOn=%soundsOn%" >> "!SETTINGS_FILE_PATH!"
REM echo "colorBKG=%colorBKG%" >> "!SETTINGS_FILE_PATH!"
REM echo "colorTXT=%colorTXT%" >> "!SETTINGS_FILE_PATH!"
REM echo "colorHIL=%colorHIL%" >> "!SETTINGS_FILE_PATH!"
REM echo "keyUp=%keyUp%" >> "!SETTINGS_FILE_PATH!"
REM echo "keyDown=%keyDown%" >> "!SETTINGS_FILE_PATH!"
REM echo "keySelect=%keySelect%" >> "!SETTINGS_FILE_PATH!"
REM echo "keySave=%keySave%" >> "!SETTINGS_FILE_PATH!"

set "saveNeeded=%FALSE%"

setlocal disabledelayedexpansion
echo.
echo Your settings are being saved...save complete!
endlocal

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:colorEcho <textToHighlight in quotes> <console background color> <text color> <highlight color>
call echo %CSI%%CSI%%%%4%%%%%3%%%~1%CSI%%%%2%%%%%3%%

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:defineEnvironmentVariable
echo %CSI%%colorBKG%%colorTXT%
cls

call :getUniqueFile "%THIS_DIRECTORY%\Rename Savegame Settings" ".ini" tempFilePath
for %%a in ("!tempFilePath!") do set "tempFileName=%%~na.ini"

set "SETTINGS_FILE_NAME=!tempFileName!"
setx SETTINGS_FILE_NAME "!tempFileName!" /M > 	nul 2>&1

if !ERRORLEVEL! EQU 5 (
	echo ERROR #5: Unknown...
)
if !ERRORLEVEL! EQU 4 (
	echo ERROR #4: You canceled the process of creating the settings file^^!
)
if !ERRORLEVEL! EQU 3 (
	echo ERROR #3: The specified registry key or value does not exist.
)
if !ERRORLEVEL! EQU 2 (
	echo ERROR #2: You need to run this program in Administrator mode! You should only need to do this when initially running the program unless some error has occurred.
)
if !ERRORLEVEL! EQU 1 (
	echo ERROR #1: An invalid parameter was passed to the command.
)

if !ERRORLEVEL! GEQ 1 (
	del "!tempFilePath!" > nul 2>&1
	
	echo The settings file could not be created for this program. You may need to run this program in Administrator mode.
	echo.
	echo Press ANY key to close the program...
	pause > nul 2>&1
	exit /b 1
)

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:loadSettings
set "savegameDirectory=%THIS_DIRECTORY%"

if "%THIS_DIRECTORY:~-21%"=="Max Payne 2 Savegames" (
	set "gameName=%MP2_NAME%"
	set "savegameExtension=%MP2_EXTENSION%"
) else (
	set "gameName=%MP1_NAME%"
	set "savegameExtension=%MP1_EXTENSION%"
)

set "useAutosaveSlot=%FALSE%"
set "useQuicksaveSlots=%FALSE%"
set "soundsOn=%TRUE%"

set "colorBKG=48;2;0;0;0;"
set "colorTXT=38;2;255;255;255m"
set "colorHIL=48;2;0;0;255;"

set "keyUp=w"
set "keyDown=s"
set "keySelect=r"
set "keySave=e"

set "saveNeeded=%TRUE%"

if defined SETTINGS_FILE_NAME (
	set "SETTINGS_FILE_PATH=%THIS_DIRECTORY%\!SETTINGS_FILE_NAME!"
	
	call :getUniqueFile "%THIS_DIRECTORY%\blank" ".txt" tempFilePath
	fc "!SETTINGS_FILE_PATH!" "!tempFilePath!" > nul 2>&1
	
	set /a "fileComparisonErrorlevel=!ERRORLEVEL!"
	del "!tempFilePath!" > nul 2>&1
	
	if !fileComparisonErrorlevel! EQU 2 (
		::delete the settings file in the case that the user changed the environment variable in some way
		del "!SETTINGS_FILE_PATH!" > nul 2>&1
		set "saveNeeded=%TRUE%"
		
		call :defineEnvironmentVariable
		
		if !ERRORLEVEL! EQU 1 (
			exit
		)
		
		set "SETTINGS_FILE_PATH=%THIS_DIRECTORY%\!SETTINGS_FILE_NAME!"
	)
	if !fileComparisonErrorlevel! EQU 1 (
		set "saveNeeded=%FALSE%"
		
		for /f "tokens=* usebackq" %%a in ("!SETTINGS_FILE_PATH!") do (
			set %%a > nul 2>&1
			
			if !ERRORLEVEL! NEQ 0 (
				set "saveNeeded=%TRUE%"
				break
			)
		)
	)
	if !fileComparisonErrorlevel! EQU 0 (
		set "saveNeeded=%TRUE%"
	)
) else if not defined SETTINGS_FILE_NAME (
	call :defineEnvironmentVariable
	
	if !ERRORLEVEL! EQU 1 (
		exit
	)
	
	set "SETTINGS_FILE_PATH=%THIS_DIRECTORY%\!SETTINGS_FILE_NAME!"
)

set "savegameSlotUsed=%FALSE%"
set "saveRenamed=%FALSE%"

if %useAutosaveSlot%==%TRUE% (
	set "autosaveSlotText=%AUTOSAVE_SLOT_YES_TEXT%
) else (
	set "autosaveSlotText=%AUTOSAVE_SLOT_NO_TEXT%
)

if %useQuicksaveSlots%==%TRUE% (
	set "quicksaveSlotText=%QUICKSAVE_SLOT_YES_TEXT%"
) else (
	set "quicksaveSlotText=%QUICKSAVE_SLOT_NO_TEXT%"
)

exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:displaySettings
echo :::::::::::::::::: SETTINGS ::::::::::::::::::
echo :: Rename savegames to autosave slot? !autosaveSlotText! ::
echo :: Rename savegames to quicksave slots? !quicksaveSlotText! ::
echo ::::::::::::::::::::::::::::::::::::::::::::::

exit /b